///////////////////////////////////////////////////////////////////////////////
//  untCGI:                                                                  //
//  CGI Web module to process SOAP method calls.                             //
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//  Written for the January/February 2001 issue of                           //
//  "uk-bug developer's magazine"                                            //
//  by Rob Bracken                                                           //
//  Bracken Software Limited                                                 //
//  01275 843215                                                             //
///////////////////////////////////////////////////////////////////////////////

unit untCGI;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, XDOM, untSOAPAdder,
  untSOAPAdderStub;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModuleCreate(Sender: TObject);
    procedure WebModuleDestroy(Sender: TObject);
  private
    { Private declarations }

    FAdder: TAdder;
    FAdderStub: TAdderStub;

  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}

uses
  CGIApp;

function DecodePost(Instring: string): string;
{ Decode the request string provided as the POST request }
var
  nChar: integer;
begin
  // Characters which mean something to a browser are coded by the NMHTTP
  // component, so we must decode them before we can use the XML
  // The character is converted to a 2 digit Hex code and prefixed with "%"

  Result := '';
  nChar := 1;                           // Point to 1st char in string
  while nChar < Length (Instring) do
  begin
    if Instring[nChar] = '%' then
    begin
      Result := Result + chr(StrToInt('$' + Copy(Instring, nChar + 1, 2)));
      Inc(nChar, 3);
    end
    else
    begin
      if Instring[nChar] = '+' then
        Result := Result + ' '
      else
        Result := Result + Instring[nChar];
      Inc(nChar);
    end;
  end;

end;

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  sTemp: string;
begin
  sTemp := DecodePost(Request.Content);
  Response.Content := FAdderStub.Execute(sTemp);
end;

procedure TWebModule1.WebModuleCreate(Sender: TObject);
begin
  FAdder := TAdder.Create;
  FAdderStub := TAdderStub.Create(FAdder);
end;

procedure TWebModule1.WebModuleDestroy(Sender: TObject);
begin
  FAdderStub.Free;
  FAdder.Free;
end;

end.
